<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use Carbon\Carbon;
use App\Http\Providers\iam\core\model\OracleOCIConnector;

class StgpelniscmrcvintModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "stg_pelni_scm_rcv_int";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "stgpelniscmrcvint";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "transaction_number",
        "header_interface_id",
        "vendor_id",
        "vendor_name",
        "creation_date",
        "transfer_date",
        "last_update_date", // ga dimasukin ke oracle
        "processing_status_code",
        "receipt_source_code",
        "transaction_type",
        "validation_flag",
        "auto_transact_code",
        "flagsync",
        "attribute1",
        "attribute14",
        "total_line"
    ];

    public static function prepareSaveToOracle()
    {
        $start = 0;
        $limit = 100;
        $nRepeat = 0;
        (new LogsyncoracleModel)->setLogSync("Penerimaan Barang PO", Carbon::now()->toDateTimeString(), "", "start");
        do {
            $stagings = (new StgpelniscmrcvintModel())->getQuery()
                ->whereNull("stgpelniscmrcvint.flagsync")
                ->orWhere("stgpelniscmrcvint.flagsync", "<", 1)
                ->offset($start)->limit($limit)->get();
            foreach ($stagings as $stag) {
                if ((new StgpelniscmrcvintModel())->saveToOracle($stag)) {
                    $updateStg = self::find($stag->id);
                    $updateStg->flagsync = 1;
                    $updateStg->update();
                }
            }
            if (count($stagings) < $limit) {
                $repeat = false;
            } else {
                $repeat = true;
                $start += $limit;
            }
            if (count($stagings) > 0) {
                $nRepeat++;
            }
        } while ($repeat);
        if ($nRepeat > 0) {
            (new LogsyncoracleModel)->setLogSync("Penerimaan Barang PO", Carbon::now()->toDateTimeString(), "", "success");
        }
    }

    public function saveToOracle($data)
    {
        $query = "INSERT INTO pelni_scm_rcv_int 
(TRANSACTION_NUMBER,HEADER_INTERFACE_ID,VENDOR_ID,VENDOR_NAME,TRANSFER_DATE,CREATION_DATE,PROCESSING_STATUS_CODE,RECEIPT_SOURCE_CODE,TRANSACTION_TYPE,VALIDATION_FLAG,
AUTO_TRANSACT_CODE, ATTRIBUTE1, TOTAL_LINE, ATTRIBUTE14) VALUES ('" . $data->transaction_number . "','" . $data->header_interface_id . "','" . $data->vendor_id . "','" . $data->vendor_name . "',
TO_DATE('" . Carbon::parse($data->transfer_date)->format("Y-m-d") . "', 'yyyy-mm-dd'),
TO_DATE('" . Carbon::parse($data->creation_date)->format("Y-m-d") . "', 'yyyy-mm-dd'),
'" . $data->processing_status_code . "','" . $data->receipt_source_code . "','" . $data->transaction_type . "',
'" . $data->validation_flag . "','" . $data->auto_transact_code . "','" . $data->attribute1 . "', '" . $data->total_line . "', '" . $data->attribute14 . "')";
        try {
            $oracleOCI = new OracleOCIConnector();
            $oracleOCI->getConnection()->insert($query)->execute();
            (new LogsyncoracleModel)->setLogSync("Penerimaan Barang PO : ".$data->transaction_number." - ".$data->attribute1, Carbon::now()->toDateTimeString(), "", "posted");
            $oracleOCI->closeConnection();
            return true;
        } catch (\Exception $e) {
            (new LogsyncoracleModel)->setLogSync("Penerimaan Barang PO : ".$data->transaction_number." - ".$data->attribute1, Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
            return false;
        }
    }
}